/**
 * Created by charles on 16/7/14.
 */
(function (global) {
    var head = document.getElementsByTagName('head')[0],
        currentScript = document.currentScript,
        configFile = currentScript.getAttribute('data-config'),
        mainFile = currentScript.getAttribute('data-main'),
        modules = currentScript.getAttribute('data-module'),
        task = [];

    task.push(loadScript('/resource/bundles/angular.bundle.js'));
    modules && modules.split(',').forEach(function(module){
        task.push(loadScript('/resource/bundles/' + module +'.bundle.js'));
    });

    task.push(loadScript('/resource/system.src.js'));
    task.push(loadScript('/resource/systemjs.config.js'));

    if (configFile) {
        task.push(loadScript(configFile));
    }

    Promise.all(task).then(function () {
        System.import(mainFile).catch(function (err) {
            console.error(err);
        });
    });

    function loadScript(url, callback) {
        return new Promise(function (resolve, reject) {
            var script = document.createElement('script');
            script.async = false;
            script.onload = function (e) {
                resolve();
            }
            script.type = 'text/javascript';
            script.src = url;
            head.appendChild(script);
        });
    }

})(this);