/**
 * System configuration for Angular 2 samples
 * Adjust as necessary for your application needs.
 */
(function(global) {
    var map = {
        'angular2-in-memory-web-api': 'node_modules/angular2-in-memory-web-api',
    };
    var packages = {
        'angular2-in-memory-web-api': { main: 'index.js', defaultExtension: 'js' },
    };
    var ngPackageNames = [
        'common',
        'compiler',
        'core',
        'forms',
        'http',
        'platform-browser',
        'platform-browser-dynamic',
        'router',
        'router-deprecated',
        'upgrade',
    ];
    var modulePackage = ['core', 'complex'];

    ngPackageNames.forEach(function(pkgName){
        System.set('@angular/'+pkgName, System.newModule(angular));
    });

    modulePackage.forEach(function(pkgName){
        if(global[pkgName]) {
            System.set(pkgName, System.newModule(global[pkgName]));
        } else {
            map[pkgName] = 'http://10.8.204.156:4000/javascripts/' + pkgName + '.bundle.js';
        }
    });

    var config = {
        map: map,
        packages: packages
    };
    System.defaultJSExtensions = true;
    System.config(config);

    function merge(source, target){
        for(var k in target) {
            if(target.hasOwnProperty(k)) {
                // console.log(k, target[k]);
                if(!source[k]) {
                    source[k] = target[k];
                } else if(typeof target[k] === 'object' && !(target[k] instanceof Array)){
                    source[k] = merge(source[k], target[k]);
                }
            }
        }
        return source;
    }
    var originalFn = System.config;
    System.config = function(obj){
        originalFn.apply(this, [merge(config, obj)]);
    }
})(this);
